import logging
import threading
import time


class ledWorker(threading.Thread):
    """
    This is the thread that runs the main loop
    and actually drives the LED
    """

    def __init__(self, parent):
        super().__init__(name=parent.name, daemon=True)
        self.log = logging.getLogger(self.__class__.__name__)
        self.parent = parent

        # self.changed = self.parent.changed

        self.stop_event = threading.Event()

    def run(self):

        while True:
            item = self.parent.queue.get()
            # Empty item, we exit
            if item == ([], [], []):
                break

            # Initial loop
            self.log.debug('running initial steps')
            for value, delay in item[0]:
                self.parent.setValue(value)
                time.sleep(delay)

            self.log.debug('running main loop')
            while True:
                for value, delay in item[1]:
                    self.parent.setValue(value)
                    time.sleep(delay)
                if not self.parent.queue.empty():
                    break

            self.log.debug('running final steps')
            for value, delay in item[2]:
                self.parent.setValue(value)
                time.sleep(delay)
